package appl.ext;

import javax.swing.SwingUtilities;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.WindowConstants;
import java.awt.Dimension;

/**
 * Displays the {@link XuluConfig} in a frame based using the
 * {@link ConfigurationEditorEngine}. This class is independent of Xulu and may
 * be used separately.
 * 
 * @author Dominik Appl
 */
public class ConfigurationEditor extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				ConfigurationEditor thisClass = new ConfigurationEditor();
				thisClass.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public ConfigurationEditor() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(621, 445);
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setContentPane(new ConfigurationEditorEngine().getGUI());
		this.setTitle("Xulu Configuration Editor");
	}

	public void dispose() {
		XuluConfig.getXuluConfig().store();
		System.exit(0);
	}

} // @jve:decl-index=0:visual-constraint="10,10"
