package appl.ext;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.Dimension;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.BoxLayout;

import edu.bonn.xulu.gui.XuluInternalFrame;

import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.ListSelectionModel;
import javax.swing.JLabel;
import javax.swing.border.SoftBevelBorder;
import javax.swing.BorderFactory;
import javax.swing.border.BevelBorder;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;

/**
 * Displays the properties of {@link XuluConfig}. The interesting stuff happens
 * in {@link ConfigurationEditorEngine}.
 * 
 * @see XuluConfig
 * @see ConfigurationEditorEngine
 * @author Dominik Appl
 */
public class ConfigurationEditorGUI extends JPanel {

	private static final long serialVersionUID = 1L;

	JList keyList = null;

	JScrollPane scrollPane = null;

	JTable entryTable = null;

	private JPanel jPanel = null;

	private JPanel jPanel1 = null;

	private JLabel jLabel = null;

	private JScrollPane jScrollPane = null;

	JTextArea docArea = null;

	private JLabel jLabel1 = null;

	private JPanel jPanel2 = null;

	/**
	 * This is the default constructor
	 */
	public ConfigurationEditorGUI() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
		gridBagConstraints4.insets = new Insets(0, 0, 0, 0);
		gridBagConstraints4.gridy = 0;
		gridBagConstraints4.ipady = 0;
		gridBagConstraints4.gridwidth = 1;
		gridBagConstraints4.weightx = 1.0;
		gridBagConstraints4.weighty = 1.0;
		gridBagConstraints4.fill = GridBagConstraints.BOTH;
		gridBagConstraints4.ipadx = 0;
		gridBagConstraints4.gridx = 1;
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.gridx = 0;
		gridBagConstraints3.ipadx = 135;
		gridBagConstraints3.ipady = 0;
		gridBagConstraints3.anchor = GridBagConstraints.WEST;
		gridBagConstraints3.fill = GridBagConstraints.VERTICAL;
		gridBagConstraints3.gridheight = 1;
		gridBagConstraints3.gridwidth = 1;
		gridBagConstraints3.weightx = 0.0;
		gridBagConstraints3.weighty = 1.0;
		gridBagConstraints3.gridy = 0;
		this.setLayout(new GridBagLayout());
		this.setSize(682, 239);
		this.add(getJPanel(), gridBagConstraints3);
		this.add(getJPanel1(), gridBagConstraints4);
	}

	/**
	 * This method initializes keyList
	 * 
	 * @return javax.swing.JList
	 */
	private JList getKeyList() {
		if (keyList == null) {
			keyList = new JList();
			keyList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return keyList;
	}

	/**
	 * This method initializes scrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getScrollPane() {
		if (scrollPane == null) {
			scrollPane = new JScrollPane();
			scrollPane.setViewportView(getEntryTable());
		}
		return scrollPane;
	}

	/**
	 * This method initializes entryTable
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getEntryTable() {
		if (entryTable == null) {
			entryTable = new JTable();
		}
		return entryTable;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = GridBagConstraints.BOTH;
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.ipadx = 0;
			gridBagConstraints2.ipady = 0;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.weighty = 1.0;
			gridBagConstraints2.insets = new Insets(0, 10, 10, 10);
			gridBagConstraints2.gridx = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new Insets(5, 0, 5, 0);
			gridBagConstraints.gridy = 0;
			gridBagConstraints.gridx = 0;
			jLabel = new JLabel();
			jLabel.setText("Category:");
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.add(jLabel, gridBagConstraints);
			jPanel.add(getJScrollPane(), gridBagConstraints2);
		}
		return jPanel;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.insets = new Insets(0, 0, 1, 0);
			gridBagConstraints8.gridy = 1;
			gridBagConstraints8.ipadx = 419;
			gridBagConstraints8.ipady = 0;
			gridBagConstraints8.fill = GridBagConstraints.NONE;
			gridBagConstraints8.gridx = 0;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.fill = GridBagConstraints.BOTH;
			gridBagConstraints7.gridy = 0;
			gridBagConstraints7.ipadx = 55;
			gridBagConstraints7.ipady = 0;
			gridBagConstraints7.weightx = 1.0;
			gridBagConstraints7.weighty = 1.0;
			gridBagConstraints7.insets = new Insets(25, 0, 0, 10);
			gridBagConstraints7.gridx = 0;
			jLabel1 = new JLabel();
			jLabel1.setText("Documentation:");
			jLabel1.setVerticalAlignment(SwingConstants.TOP);
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.anchor = GridBagConstraints.EAST;
			gridBagConstraints1.insets = new Insets(0, 150, 0, 0);
			gridBagConstraints1.gridx = -1;
			gridBagConstraints1.gridy = -1;
			gridBagConstraints1.ipady = 0;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.weighty = 1.0;
			gridBagConstraints1.fill = GridBagConstraints.BOTH;
			jPanel1 = new JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jPanel1.add(getScrollPane(), gridBagConstraints7);
			jPanel1.add(getJPanel2(), gridBagConstraints8);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setPreferredSize(new Dimension(100, 100));
			jScrollPane.setViewportView(getKeyList());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes docArea
	 * 
	 * @return javax.swing.JTextArea
	 */
	private JTextArea getDocArea() {
		if (docArea == null) {
			docArea = new JTextArea();
			docArea.setPreferredSize(new Dimension(0, 50));
			docArea.setText("<select a value to see its documentation>");
			docArea.setRows(2);
			docArea.setLineWrap(true);
			docArea.setEditable(false);
		}
		return docArea;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints6.gridy = 1;
			gridBagConstraints6.ipadx = 0;
			gridBagConstraints6.ipady = 21;
			gridBagConstraints6.weightx = 1.0;
			gridBagConstraints6.weighty = 1.0;
			gridBagConstraints6.insets = new Insets(0, 0, 10, 10);
			gridBagConstraints6.gridx = 1;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints5.gridy = 0;
			gridBagConstraints5.anchor = GridBagConstraints.WEST;
			gridBagConstraints5.gridx = 1;
			jPanel2 = new JPanel();
			jPanel2.setLayout(new GridBagLayout());
			jPanel2.add(jLabel1, gridBagConstraints5);
			jPanel2.add(getDocArea(), gridBagConstraints6);
		}
		return jPanel2;
	}

} // @jve:decl-index=0:visual-constraint="10,10"
