package appl.parallel.gui;

import javax.swing.JPanel;
import java.awt.GridBagLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.BoxLayout;
import javax.swing.ListSelectionModel;
import java.awt.Insets;
import javax.swing.border.SoftBevelBorder;
import javax.swing.table.DefaultTableModel;
import edu.bonn.xulu.XuluModellingPlatform;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import java.awt.Rectangle;

/**
 * The GUI for the ParallelControlPanel . All the interesting 
 * stuff happens in the {@link ParallelControlPanelEngine}.
 * This GUI was created with the Visual Editor plugin for eclipse. 
 * Editing with another VE may be a bad idea.
 *  
 * @author Dominik Appl
 */
public class ParallelControlPanel extends JPanel {

	static final long serialVersionUID = 1L;

	JPanel executionPanel = null;

	JLabel Steps = null;

	JTable computingResourcesList = null;

	JScrollPane jScrollPane1 = null;

	JPanel jPanel = null;

	JScrollPane jScrollPane = null;

	SimplePropertyTable propertyTable = null;

	JButton refreshButton = null;

	JButton selectAllButton = null;

	JPanel buttonPanel = null;

	/**
	 * This is the default constructor. It should be only used be the eclipse VE
	 */
	public ParallelControlPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		this.setSize(578, 268);
		this.add(getExecutionPanel(), null);
		this.add(getJPanel(), null);
	}

	/**
	 * This method initializes executionPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getExecutionPanel() {
		if (executionPanel == null) {
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 1;
			gridBagConstraints12.gridy = 2;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.fill = GridBagConstraints.BOTH;
			gridBagConstraints11.weighty = 1.0;
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.gridy = 1;
			gridBagConstraints11.ipadx = 0;
			gridBagConstraints11.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints11.gridwidth = 2;
			gridBagConstraints11.weightx = 1.0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints.gridy = 0;
			gridBagConstraints.anchor = GridBagConstraints.NORTH;
			gridBagConstraints.gridheight = 1;
			gridBagConstraints.gridwidth = 2;
			gridBagConstraints.gridx = 0;
			Steps = new JLabel();
			Steps.setText("Computing resources:");
			Steps.setName("Steps");
			executionPanel = new JPanel();
			executionPanel.setLayout(new GridBagLayout());
			executionPanel.setBorder(new SoftBevelBorder(
					SoftBevelBorder.LOWERED));
			executionPanel.setVisible(true);
			executionPanel.add(Steps, gridBagConstraints);
			executionPanel.add(getJScrollPane1(), gridBagConstraints11);
			executionPanel.add(getButtonPanel(), gridBagConstraints12);
		}
		return executionPanel;
	}

	/**
	 * This method initializes computingResourcesList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JTable getComputingResourcesList() {
		if (computingResourcesList == null) {
			computingResourcesList = new JTable();
			computingResourcesList.setShowHorizontalLines(false);
			computingResourcesList
					.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		}
		return computingResourcesList;
	}

	/**
	 * This method initializes jScrollPane1	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setName("jScrollPane1");
			jScrollPane1.setViewportView(getComputingResourcesList());
			jScrollPane1.setPreferredSize(new Dimension(200, 250));
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.BOTH;
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.weighty = 1.0;
			gridBagConstraints1.gridx = 0;
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.add(getJScrollPane(), gridBagConstraints1);
		}
		return jPanel;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getPropertyTable());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes propertyTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getPropertyTable() {
		if (propertyTable == null) {
			propertyTable = new SimplePropertyTable();
		}
		return propertyTable;
	}

	/**
	 * This method initializes refreshButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getRefreshButton() {
		if (refreshButton == null) {
			refreshButton = new JButton();
			refreshButton.setName("refreshButton");
			refreshButton.setText("Refresh");
		}
		return refreshButton;
	}

	/**
	 * This method initializes selectAllButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSelectAllButton() {
		if (selectAllButton == null) {
			selectAllButton = new JButton();
			selectAllButton.setText("Select available");
		}
		return selectAllButton;
	}

	/**
	 * This method initializes buttonPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	protected JPanel getButtonPanel() {
		if (buttonPanel == null) {
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.anchor = GridBagConstraints.SOUTHEAST;
			gridBagConstraints3.gridy = -1;
			gridBagConstraints3.gridx = -1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.anchor = GridBagConstraints.CENTER;
			gridBagConstraints2.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints2.gridheight = 1;
			gridBagConstraints2.gridwidth = 1;
			gridBagConstraints2.gridx = -1;
			gridBagConstraints2.gridy = -1;
			gridBagConstraints2.ipadx = 0;
			gridBagConstraints2.ipady = 0;
			gridBagConstraints2.weightx = 0.5;
			gridBagConstraints2.fill = GridBagConstraints.HORIZONTAL;
			buttonPanel = new JPanel();
			buttonPanel.setLayout(new GridBagLayout());
			buttonPanel.add(getRefreshButton(), gridBagConstraints2);
			buttonPanel.add(getSelectAllButton(), gridBagConstraints3);
		}
		return buttonPanel;
	}

} //  @jve:decl-index=0:visual-constraint="10,10"
