package appl.parallel.gui;

import java.util.Enumeration;
import java.util.Iterator;
import java.util.Properties;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

/**
 * Just a simple 2 column Property Table
 * 
 * @author Dominik Appl
 */
public class SimplePropertyTable extends JTable {

	private final String colname1;

	private final String colname2;

	public SimplePropertyTable(String colname1, String colname2) {
		super(1, 2);
		this.colname1 = colname1;
		this.colname2 = colname2;

	}

	public SimplePropertyTable() {
		this("Property", "Value");
	}

	public void setPropertyData(Properties propdata) {
		Enumeration keys = propdata.keys();
		// Create array
		String[][] data = new String[propdata.size()][2];
		int i = 0;
		while (keys.hasMoreElements()) {
			data[i][0] = (String) keys.nextElement();
			data[i][1] = (String) propdata.getProperty(data[i][0]);
			i++;
		}
		setModel(new DefaultTableModel(data,
				new String[] { colname1, colname2 }));
	}

}
