package appl.parallel.plugin.event;

import javax.swing.JMenuItem;
import javax.swing.JTable;

import appl.parallel.client.RemoteExecutionController;
import appl.parallel.event.TimeEvent;
import appl.parallel.event.TransferEvent;

import edu.bonn.xulu.appl.XuluPlugin;
import edu.bonn.xulu.gui.XuluInternalFrame;
import edu.bonn.xulu.plugin.appl.AbstractMenuPlugin;

/**
 * The {@link XuluPlugin} logs {@link TransferEvent}s and {@link TimeEvent}s.
 * The Events are displayed in a sortable {@link JTable}.
 * 
 * @author Dominik Appl
 */
public class SimpleCommEventMonitorPlugin extends AbstractMenuPlugin {

	/**
	 * Creates a new plugin
	 */
	public SimpleCommEventMonitorPlugin() {
		super(4, "Xulu/V Communication Monitor");
		// TODO Auto-generated constructor stub
	}

	/**
	 * Creates a new plugin
	 * 
	 * @param xuluMenuNo
	 *            the position of the menu in the menubar
	 * @param menuItem
	 *            the menu to insert
	 */
	public SimpleCommEventMonitorPlugin(int xuluMenuNo, JMenuItem menuItem) {
		super(xuluMenuNo, menuItem);
		// TODO Auto-generated constructor stub
	}

	/**
	 * Creates a new plugin
	 * 
	 * @param xuluMenuNo
	 *            the position of the menu in the menubar
	 * @param menuItemName
	 *            the name of the entry to insert
	 */
	public SimpleCommEventMonitorPlugin(int xuluMenuNo, String menuItemName) {
		super(xuluMenuNo, menuItemName);
		// TODO Auto-generated constructor stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.bonn.xulu.plugin.appl.AbstractMenuPlugin#createPluginApplication()
	 */
	@Override
	protected XuluInternalFrame createPluginApplication() throws Exception {
		RemoteExecutionController controller = RemoteExecutionController
				.getRemoteExecutionController(appl);
		if (controller == null)
			throw new UnsupportedOperationException(
					"Remote Execution Monitor plugin not found!");
		SimpleCommEventMonitorEngine engine = new SimpleCommEventMonitorEngine(
				controller.getEventProxy());
		return engine.getMonitor();
	}

}
