package appl.parallel.starter.client;

import javax.swing.JPanel;
import java.awt.GridBagLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.BoxLayout;
import javax.swing.ListSelectionModel;
import java.awt.Insets;
import javax.swing.border.SoftBevelBorder;
import javax.swing.table.DefaultTableModel;
import edu.bonn.xulu.XuluModellingPlatform;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import appl.parallel.gui.ParallelControlPanelEngine;

import java.awt.Rectangle;
import javax.swing.JList;
import java.awt.CardLayout;
import java.awt.GridLayout;

/**
 * The GUI for the XuluStarterController . The events are controlled by the
 * {@link XuluStarterController}. This GUI was created with the Visual Editor
 * plugin for eclipse and should be edited using this VE.
 * 
 * @author Dominik Appl
 */
public class XuluStarterClientPanel extends JPanel {

	static final long serialVersionUID = 1L;

	JPanel executionPanel = null;

	JLabel Steps = null;

	JScrollPane jScrollPane1 = null;

	JPanel buttonPanel = null;

	JList serverList = null;

	JButton refreshButton = null;

	JButton startButton = null;

	JButton stopButton = null;

	JButton restartButton = null;

	/**
	 * This is the default constructor. It should be only used be the eclipse VE
	 */
	public XuluStarterClientPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		this.setSize(248, 292);
		this.add(getExecutionPanel(), null);
	}

	/**
	 * This method initializes executionPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getExecutionPanel() {
		if (executionPanel == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 1;
			gridBagConstraints1.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints1.insets = new Insets(0, 5, 5, 5);
			gridBagConstraints1.gridy = 4;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 1;
			gridBagConstraints12.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints12.insets = new Insets(0, 5, 5, 5);
			gridBagConstraints12.gridy = 3;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.fill = GridBagConstraints.BOTH;
			gridBagConstraints11.weighty = 1.0;
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.gridy = 1;
			gridBagConstraints11.ipadx = 0;
			gridBagConstraints11.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints11.gridwidth = 2;
			gridBagConstraints11.weightx = 1.0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints.gridy = 0;
			gridBagConstraints.anchor = GridBagConstraints.NORTH;
			gridBagConstraints.gridheight = 1;
			gridBagConstraints.gridwidth = 2;
			gridBagConstraints.gridx = 0;
			Steps = new JLabel();
			Steps.setText("Potential Servers");
			Steps.setName("Steps");
			executionPanel = new JPanel();
			executionPanel.setLayout(new GridBagLayout());
			executionPanel.setBorder(new SoftBevelBorder(
					SoftBevelBorder.LOWERED));
			executionPanel.setVisible(true);
			executionPanel.add(Steps, gridBagConstraints);
			executionPanel.add(getJScrollPane1(), gridBagConstraints11);
			executionPanel.add(getButtonPanel(), gridBagConstraints12);
			executionPanel.add(getRefreshButton(), gridBagConstraints1);
		}
		return executionPanel;
	}

	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setName("jScrollPane1");
			jScrollPane1.setViewportView(getServerList());
			jScrollPane1.setPreferredSize(new Dimension(200, 250));
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes buttonPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	protected JPanel getButtonPanel() {
		if (buttonPanel == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(1);
			buttonPanel = new JPanel();
			buttonPanel.setLayout(gridLayout);
			buttonPanel.add(getStartButton(), null);
			buttonPanel.add(getStopButton(), null);
			buttonPanel.add(getRestartButton(), null);
		}
		return buttonPanel;
	}

	/**
	 * This method initializes serverList
	 * 
	 * @return javax.swing.JList
	 */
	private JList getServerList() {
		if (serverList == null) {
			serverList = new JList();
			serverList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return serverList;
	}

	/**
	 * This method initializes refreshButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getRefreshButton() {
		if (refreshButton == null) {
			refreshButton = new JButton();
			refreshButton.setText("Refresh");
		}
		return refreshButton;
	}

	/**
	 * This method initializes startButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getStartButton() {
		if (startButton == null) {
			startButton = new JButton();
			startButton.setText("Start");
			startButton.setName("startButton");
		}
		return startButton;
	}

	/**
	 * This method initializes stopButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getStopButton() {
		if (stopButton == null) {
			stopButton = new JButton();
			stopButton.setText("Stop");
			stopButton.setName("stopButton");
		}
		return stopButton;
	}

	/**
	 * This method initializes restartButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getRestartButton() {
		if (restartButton == null) {
			restartButton = new JButton();
			restartButton.setText("Restart");
			restartButton.setName("restartButton");
		}
		return restartButton;
	}

} // @jve:decl-index=0:visual-constraint="10,10"
