package appl.parallel.test;


import java.awt.Rectangle;
import java.io.File;
import java.io.FileNotFoundException;
import appl.parallel.spmd.split.WritableGridPartition;
import appl.parallel.util.PartitionUtil;
import appl.util.RasterUtil;
import schmitzm.data.WritableGridRaster;
import schmitzm.geotools.io.GeoExportUtil;
import schmitzm.geotools.io.GeoImportUtil;

/**
 * Simple JUnit Test
 * @author Dominik Appl
 */
public class PartitialGridTest {

	/**
	 * @throws java.lang.Exception
	 */
	public void setUp() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	public void tearDown() throws Exception {
	}

	/**
	 * Test method for {@link appl.parallel.util.PartitionUtil#getPartitialGrid2D(schmitzm.data.WritableGrid, Rectangle, int)}.
	 */
	public void testGetPartitialGrid2D() {
		WritableGridRaster baseGrid;
		try {
			baseGrid = GeoImportUtil
					.readGridRasterFromArcInfoASCII(new File(
							"../Xulu-Data/minigrid.arc"));
			GeoExportUtil.writeGridRasterToArcInfoASCII(baseGrid, new File(
					"TEST_getpartitialgrid2d_o1"));
			RasterUtil.printGrid(baseGrid, 4, 0, "base partition");
			//make five partitions: four quarters and one inner partition
					RasterUtil.printGrid(PartitionUtil.getPartitialGrid2D(baseGrid, new Rectangle(0, 0, 5, 5),0),4,0, "upperleft partition");
					RasterUtil.printGrid(PartitionUtil.getPartitialGrid2D(baseGrid,new Rectangle( 5, 0, 5, 5),0),4,0, "upperright partition");
					RasterUtil.printGrid(PartitionUtil.getPartitialGrid2D(baseGrid, new Rectangle(0, 5, 5, 5),0),4,0, "lowerleft partition");
					RasterUtil.printGrid(PartitionUtil.getPartitialGrid2D(baseGrid, new Rectangle(5, 5, 5, 5),0),4,0, "lowerright partition");
					WritableGridPartition baseGrid2 = PartitionUtil.getPartitialGrid2D(baseGrid,new Rectangle( 0, 0, 10, 10),0);
					System.out.println("********************* Starting test 2 *********************");
					RasterUtil.printGrid(baseGrid2,5,0, "baseGrid2");
					WritableGridPartition baseGrid2partition = PartitionUtil.getPartitialGrid2D(baseGrid, new Rectangle(0, 0, 5, 5),0);
					RasterUtil.printGrid(baseGrid2partition,5,0, "baseGrid2 partition");
					baseGrid2.setPartition(baseGrid2partition, new Rectangle(1,1,5,5));
					RasterUtil.printGrid(baseGrid2,5,0, "baseGrid2 (after setting baseGrid2-partition to (1,1)");

		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
