package appl.plugin.multimodelcontrol;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JSplitPane;
import java.awt.GridBagLayout;
import java.awt.Dimension;
import javax.swing.JList;
import java.awt.GridBagConstraints;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JRadioButton;
import javax.swing.BoxLayout;
import java.awt.CardLayout;
import javax.swing.DefaultListModel;
import javax.swing.ListSelectionModel;
import javax.swing.BorderFactory;
import javax.swing.border.EtchedBorder;
import java.awt.FlowLayout;
import java.awt.Insets;
import java.awt.GridLayout;
import javax.swing.border.SoftBevelBorder;
import java.awt.ComponentOrientation;
import java.awt.Cursor;
import javax.swing.plaf.multi.MultiPanelUI;
import javax.swing.plaf.basic.BasicPanelUI;
import javax.swing.JCheckBox;
import javax.swing.SwingConstants;
import javax.swing.JToggleButton;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;

import javax.swing.JTabbedPane;

import edu.bonn.xulu.XuluModellingPlatform;
import edu.bonn.xulu.gui.XuluInternalFrame;
import javax.swing.JScrollPane;
import appl.parallel.gui.ParallelControlPanel;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.JTextPane;
import javax.swing.JTextArea;
import javax.swing.border.TitledBorder;
import java.awt.Color;

// fuer Doku
import appl.parallel.gui.ParallelControlPanelEngine;

/**
 * The GUI for the ModelControlCenter (MCC). All the interesting stuff happens in the
 * {@link ParallelControlPanelEngine}.
 * This GUI was created with the Visual Editor plugin for eclipse.
 *
 * @author Dominik Appl
 */
public class MultiModelControlFrame extends XuluInternalFrame {

	 static final long serialVersionUID = 1L;
	 JPanel jContentPane = null;
     JPanel modelPanel = null;
     JPanel synchronisationPanel = null;
     JList modelList = null;
     JLabel loadedModels = null;
     JList syncCommandList = null;
     JLabel syncPanelName = null;
     JButton addStepCommand = null;
     JButton newOverAllStep = null;
     JButton clearModelSteps = null;
     JPanel syncButtonsPanel = null;
     JScrollPane jScrollPane = null;
	 private JPanel jPanel = null;
	private JPanel controlPanel = null;
	 JButton startButton = null;
	 JButton stepButton = null;
	 JButton stopButton = null;
	private JPanel jPanel3 = null;
	private JScrollPane jScrollPane1 = null;
	private JPanel jPanel5 = null;
	private JScrollPane jScrollPane2 = null;
	private JLabel jLabel3 = null;
	JTextArea console = null;


	public MultiModelControlFrame() {
		super("Multi Model ControlFrame");
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		this.setSize(486, 395);
		this.setContentPane(getJContentPane());
		this.setTitle("Multi Model Control");
		this.setClosable(true);
		this.setDefaultCloseOperation(HIDE_ON_CLOSE);
	}
	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BoxLayout(getJContentPane(), BoxLayout.Y_AXIS));
			jContentPane.add(getControlPanel(), null);
			jContentPane.add(getJPanel(), null);
			jContentPane.add(getJPanel5(), null);
		}
		return jContentPane;
	}
    /**
	 * This method initializes modelPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getModelPanel() {
		if (modelPanel == null) {
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.insets = new Insets(0, 0, 2, 0);
			gridBagConstraints3.gridy = 2;
			gridBagConstraints3.ipadx = 0;
			gridBagConstraints3.ipady = 0;
			gridBagConstraints3.gridx = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = GridBagConstraints.BOTH;
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.ipadx = 0;
			gridBagConstraints2.ipady = 0;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.weighty = 1.0;
			gridBagConstraints2.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints2.gridx = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new Insets(3, 3, 3, 3);
			gridBagConstraints.gridy = 0;
			gridBagConstraints.ipadx = 0;
			gridBagConstraints.gridx = 0;
			loadedModels = new JLabel();
			loadedModels.setText("Models");
			loadedModels.setMinimumSize(new Dimension(86, 10));
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.BOTH;
			gridBagConstraints1.weighty = 1.0;
			gridBagConstraints1.weightx = 1.0;
			modelPanel = new JPanel();
			modelPanel.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			modelPanel.setName("modelPanel");
			modelPanel.setLayout(new GridBagLayout());
			modelPanel.add(loadedModels, gridBagConstraints);
			modelPanel.add(getJScrollPane(), gridBagConstraints2);
			modelPanel.add(getAddStepCommand(), gridBagConstraints3);
		}
		return modelPanel;
	}

    /**
	 * This method initializes synchronisationPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getSynchronisationPanel() {
		if (synchronisationPanel == null) {
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.fill = GridBagConstraints.BOTH;
			gridBagConstraints11.weighty = 1.0;
			gridBagConstraints11.gridy = 1;
			gridBagConstraints11.insets = new Insets(0, 5, 2, 5);
			gridBagConstraints11.weightx = 1.0;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.insets = new Insets(0, 0, 2, 0);
			gridBagConstraints5.gridy = 11;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 0;
			gridBagConstraints7.ipady = 0;
			gridBagConstraints7.insets = new Insets(3, 0, 3, 0);
			gridBagConstraints7.gridy = 0;
			syncPanelName = new JLabel();
			syncPanelName.setText("Commands");
			synchronisationPanel = new JPanel();
			synchronisationPanel.setToolTipText("Here you can synchronize the steps of multiple models");
			synchronisationPanel.setLayout(new GridBagLayout());
			synchronisationPanel.add(syncPanelName, gridBagConstraints7);
			synchronisationPanel.add(getJScrollPane1(), gridBagConstraints11);
			synchronisationPanel.add(getSyncButtonsPanel(), gridBagConstraints5);
		}
		return synchronisationPanel;
	}
    /**
	 * This method initializes jList
	 *
	 * @return javax.swing.JList
	 */
	private JList getModelList() {
		if (modelList == null) {
			modelList = new JList();
			modelList.setName("modelList");
			modelList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			modelList.setToolTipText("All models, which are currently loaded. Doubleclick on a model to set propertys");
		}
		return modelList;
	}
    /**
	 * This method initializes jList
	 *
	 * @return javax.swing.JList
	 */
	private JList getSyncCommandList() {
		if (syncCommandList == null) {
			syncCommandList = new JList();
			syncCommandList.setToolTipText("The list of commands to be executed");

		}
		return syncCommandList;
	}

    /**
	 * This method initializes addStepCommand
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getAddStepCommand() {
		if (addStepCommand == null) {
			addStepCommand = new JButton();
			addStepCommand.setText("Add ====> ");
			addStepCommand.setPreferredSize(new Dimension(100, 20));
		}
		return addStepCommand;
	}
    /**
	 * This method initializes newOverAllStep
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getNewOverAllStep() {
		if (newOverAllStep == null) {
			newOverAllStep = new JButton();
			newOverAllStep.setText("Add Repeat");
			newOverAllStep.setPreferredSize(new Dimension(119, 20));
		}
		return newOverAllStep;
	}
    /**
	 * This method initializes clearModelSteps
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getClearModelSteps() {
		if (clearModelSteps == null) {
			clearModelSteps = new JButton();
			clearModelSteps.setText("Delete entry");
			clearModelSteps.setPreferredSize(new Dimension(64, 20));
		}
		return clearModelSteps;
	}
    /**
	 * This method initializes syncButtonsPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getSyncButtonsPanel() {
		if (syncButtonsPanel == null) {
			GridLayout gridLayout1 = new GridLayout();
			gridLayout1.setRows(1);
			gridLayout1.setColumns(2);
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.anchor = GridBagConstraints.WEST;
			gridBagConstraints9.gridx = -1;
			gridBagConstraints9.gridy = -1;
			gridBagConstraints9.fill = GridBagConstraints.HORIZONTAL;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints8.gridy = -1;
			gridBagConstraints8.gridx = -1;
			syncButtonsPanel = new JPanel();
			syncButtonsPanel.setLayout(gridLayout1);
			syncButtonsPanel.add(getNewOverAllStep(), null);
			syncButtonsPanel.add(getClearModelSteps(), null);
		}
		return syncButtonsPanel;
	}
    /* (non-Javadoc)
	 * @see edu.bonn.xulu.gui.XuluInternalFrame#refresh()
	 */
	@Override
	public void refresh() {
		// TODO Auto-generated method stub

	}

    /**
	 * This method initializes jScrollPane
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getModelList());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(1);
			gridLayout.setVgap(0);
			gridLayout.setColumns(4);
			gridLayout.setHgap(0);
			jPanel = new JPanel();
			jPanel.setLayout(gridLayout);
			jPanel.add(getModelPanel(), null);
			jPanel.add(getSynchronisationPanel(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes controlPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getControlPanel() {
		if (controlPanel == null) {
			GridLayout gridLayout3 = new GridLayout();
			gridLayout3.setRows(1);
			gridLayout3.setHgap(5);
			gridLayout3.setColumns(2);
			gridLayout3.setVgap(5);
			controlPanel = new JPanel();
			controlPanel.setMaximumSize(new Dimension(1000, 20));
			controlPanel.setLayout(gridLayout3);
			controlPanel.add(getJPanel3(), null);
		}
		return controlPanel;
	}

	/**
	 * This method initializes startButton
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getStartButton() {
		if (startButton == null) {
			startButton = new JButton();
			startButton.setText("Start");
		}
		return startButton;
	}

	/**
	 * This method initializes stepButton
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getStepButton() {
		if (stepButton == null) {
			stepButton = new JButton();
			stepButton.setText("Step");
		}
		return stepButton;
	}

	/**
	 * This method initializes stopButton
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getStopButton() {
		if (stopButton == null) {
			stopButton = new JButton();
			stopButton.setText("Stop");
		}
		return stopButton;
	}



	/**
	 * This method initializes jPanel3
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.gridx = -1;
			gridBagConstraints14.gridy = -1;
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.gridx = -1;
			gridBagConstraints13.gridy = -1;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.anchor = GridBagConstraints.WEST;
			gridBagConstraints12.gridy = -1;
			gridBagConstraints12.gridx = -1;
			jPanel3 = new JPanel();
			jPanel3.setLayout(new GridBagLayout());
			jPanel3.add(getStartButton(), gridBagConstraints12);
			jPanel3.add(getStepButton(), gridBagConstraints13);
			jPanel3.add(getStopButton(), gridBagConstraints14);
		}
		return jPanel3;
	}

	/**
	 * This method initializes jScrollPane1
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getSyncCommandList());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jPanel5
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel5() {
		if (jPanel5 == null) {
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.anchor = GridBagConstraints.NORTH;
			gridBagConstraints4.insets = new Insets(3, 0, 0, 0);
			gridBagConstraints4.gridy = 3;
			jLabel3 = new JLabel();
			jLabel3.setText("Console");
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.fill = GridBagConstraints.BOTH;
			gridBagConstraints15.weighty = 1.0;
			gridBagConstraints15.gridy = 4;
			gridBagConstraints15.gridx = 0;
			gridBagConstraints15.anchor = GridBagConstraints.SOUTH;
			gridBagConstraints15.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints15.weightx = 1.0;
			jPanel5 = new JPanel();
			jPanel5.setLayout(new GridBagLayout());
			jPanel5.add(jLabel3, gridBagConstraints4);
			jPanel5.add(getJScrollPane2(), gridBagConstraints15);
		}
		return jPanel5;
	}

	/**
	 * This method initializes jScrollPane2
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new JScrollPane();
			jScrollPane2.setViewportView(getConsole());
		}
		return jScrollPane2;
	}

	/**
	 * This method initializes console
	 *
	 * @return javax.swing.JTextArea
	 */
	private JTextArea getConsole() {
		if (console == null) {
			console = new JTextArea();
		}
		return console;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
