package appl.util;

import javax.swing.JPanel;

import edu.bonn.xulu.gui.XuluInternalFrame;
import java.awt.Dimension;

/**
 * Makes an XuluInternalFrame out of a {@link JPanel}.
 * 
 * @author Dominik Appl
 */
public class XuluFrameAdapter extends XuluInternalFrame{

	
	private final JPanel panel;



	/**
	 * Creates the internal Frame
	 * @param titel the window-title
	 * @param panel the panel to be displayed in the frame
	 */
	public XuluFrameAdapter(String titel, JPanel panel) {
		super(titel);
		this.panel = panel;
		initialize();
		   
	}

	

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
        this.setSize(new Dimension(panel.getSize().width, panel.getSize().height + 30));
        this.setClosable(true);
	    this.setDefaultCloseOperation( HIDE_ON_CLOSE );
	    this.getContentPane().add(panel);	
	}



	@Override
	public void refresh() {
		
		
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
