/** GnuR Plugin - A XULU-plugin for applying R-powered statistics on objects in the XULU-datapool.
    Copyright (C) 2007  Stefan A. Krüger

    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

    Diese Bibliothek ist freie Software; Sie dürfen sie unter den Bedingungen der GNU Lesser General Public License, wie von der Free Software Foundation veröffentlicht, weiterverteilen und/oder modifizieren; entweder gemäß Version 2.1 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
    Diese Bibliothek wird in der Hoffnung weiterverbreitet, daß sie nützlich sein wird, jedoch OHNE IRGENDEINE GARANTIE, auch ohne die implizierte Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK. Mehr Details finden Sie in der GNU Lesser General Public License.
    Sie sollten eine Kopie der GNU Lesser General Public License zusammen mit dieser Bibliothek erhalten haben; falls nicht, schreiben Sie an die Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 **/   
package de.skrueger.xulu.plugin.gnur;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.TexturePaint;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JTextArea;

public class JRTextArea extends JTextArea {
	static BufferedImage img = null;
	TexturePaint texture;
	boolean fileFound = false;
	
	public JRTextArea() {
		super();
		if (img == null)	// Open the image if not happened earlier  
		    try {
			File file = new File ("rlogo.jpg");
			System.out.println("name = "+file.getAbsolutePath());
			img = ImageIO.read( file);
		    } catch (IOException e) {
			e.printStackTrace();
		    }		
		fileFound = true;
		// Schrift ausgeben
		setOpaque(false);
	}
	
	public void paintComponent(Graphics g) {
		if (fileFound){
			Graphics2D g2 = (Graphics2D)g;
			Rectangle rect = new Rectangle(0,0, img.getWidth(null), img.getHeight(null));
			texture = new TexturePaint(img, rect);
			g2.setPaint(texture);
			g.fillRect(0, 0, getWidth(), getHeight());
			g.drawString("sds", 0, 0);
		}
		super.paintComponent(g);
	}
	
}
