### generic functions

### ============================================================================
### set start working directory automatic
locPath <- function (dest=c('data','SatData', 'model', 'model.data', 'prog')) {
  dest <- match.arg(dest)
  switch(dest, 
         data = directory <- c("i:/Benin","M:/4_Research/Benin_Daten"), 
         SatData = directory <- c("F:","M:/4_Research/Benin_Daten"),
         model = directory <- c("e:/Xulu-100m/statistics","M:/4_Research/Xulu"),
         model.data = directory <- c("e:/database_modelling","M:/4_Research/LUCC_Modelling/database_modelling"), 
         prog = directory <- c("Y:/6_Programming/R","D:/6_Programming/R") )

  # look if directory at home is available and set path apropriately
  if (!is.na(file.info(directory[2])$isdir)){locdrive = directory[2]} else {locdrive <- directory[1]}
  locdrive <- paste(locdrive,"/",sep="")
  return(locdrive)
}

### path to base path for R script files, e.g. this generic function file
locPathP <- function () {
  DirUni <- "Y:/6_Programming"
  DirHome <- "D:/6_Programming"
  if (!is.na(file.info(DirHome)$isdir)){locdrive = DirHome} else {locdrive <- DirUni}
  locdrive <- paste(locdrive,"/",sep="")
  return(locdrive)
}

### ============================================================================
### copy content of graphic device to a postscript file
### file is located in working directory
### works best if ps is given the width and height of the current device

### the option  onefile=F is essential to have the bounding box -> LATEX!

psFile <- function(file="Rplot.eps", dim, ...) {
        dev.copy2eps(file=file, width=dim[1], height=dim[2],
        horizontal = FALSE, onefile=F, paper = "special", ...)
}
