/** XULU - This file is part of the eXtendable Unified Land Use Modelling Platform (XULU)

    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

    Diese Bibliothek ist freie Software; Sie dürfen sie unter den Bedingungen der GNU Lesser General Public License, wie von der Free Software Foundation veröffentlicht, weiterverteilen und/oder modifizieren; entweder gemäß Version 2.1 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
    Diese Bibliothek wird in der Hoffnung weiterverbreitet, daß sie nützlich sein wird, jedoch OHNE IRGENDEINE GARANTIE, auch ohne die implizierte Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK. Mehr Details finden Sie in der GNU Lesser General Public License.
    Sie sollten eine Kopie der GNU Lesser General Public License zusammen mit dieser Bibliothek erhalten haben; falls nicht, schreiben Sie an die Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 **/

package edu.bonn.xulu.gui;

import edu.bonn.xulu.appl.AbstractManager;

/**
 * Diese Klasse bildet eine abstrakte Oberklasse fuer alle grafischen
 * Implementierungen des {@link AbstractManager}.
 * @author <a href="mailto:martin.schmitz@koeln.de">Martin Schmitz</a> (University of Bonn/Germany)
 * @version 1.0
 */
public abstract class AbstractManagerFrame extends XuluInternalFrame {
  /** Speichert die Manager-Instanz, die im Fenster dargestellt wird. */
  protected AbstractManager manager = null;

  /**
   * Erzeugt einen neue Instanz des grafischen Manager-Fensters.
   * @param title   Titel fuer das Fenster
   * @param manager darzustellender Manager
   */
  public AbstractManagerFrame(String title, AbstractManager manager) {
    super(title);
    this.manager = manager;
  }

  /**
   * Liefert die Objekte, welches aktuell im Manager-Fenster ausgewaehlt sind.
   * Mit diesen Objekten werden Aktionen durchgefuhrt, wenn ein Kontextmenu
   * aktiviert wurde.
   * @return <code>null</code> wenn noch kein Kontextmenue aufgerufen wurde.
   */
  public abstract AbstractManager.ContentType[] getSelectedObjects();

}
