package edu.bonn.xulu.plugin.model.sleuth;

import schmitzm.data.WritableGrid;
import schmitzm.data.property.PropertyReadAccess;
import schmitzm.data.property.PropertyWriteAccess;
import schmitzm.data.property.ScalarProperty;
import edu.bonn.xulu.model.AbstractStepModel;
import appl.util.RasterUtil;

public class CopyUrbanInActualLU extends AbstractStepModel {

	
	protected CopyUrbanInActualLUContentManager contManager;
	
	private PropertyReadAccess RA_ActualLuMap = null; 
	private PropertyReadAccess RA_ActualUrbanMap = null;
	private PropertyWriteAccess WA_ActualUrbanMap = null; // Output Grid
	private PropertyReadAccess RA_UrbanLUClass = null;
	
	private WritableGrid ActualLuMap = null; 
	private WritableGrid ActualUrbanMap = null;
	private PropertyReadAccess UrbanLUClass = null;
	
	protected int	step = 0;
	
	public CopyUrbanInActualLU() {
		super(new CopyUrbanInActualLUContentManager());
		this.contManager = (CopyUrbanInActualLUContentManager) super.contManager;
	}

	@Override
	public void performModelInit() {
		// TODO Auto-generated method stub
		if (contManager == null)
			return;
		RA_ActualLuMap = null;
		if (contManager.getResource(0).getData() != null)
			RA_ActualLuMap = ((ScalarProperty) contManager.getResource(0)
					.getData()).getReadAccess(this);
		RA_ActualUrbanMap = null;
		if (contManager.getResource(1).getData() != null)
			RA_ActualUrbanMap = ((ScalarProperty) contManager.getResource(1)
					.getData()).getReadAccess(this);
		WA_ActualUrbanMap = null;
		if (contManager.getResource(1).getData() != null)
			WA_ActualUrbanMap = ((ScalarProperty) contManager.getResource(1)
					.getData()).getWriteAccess(this);
		RA_UrbanLUClass = null;
		if (contManager.getResource(2).getData() != null)
			RA_UrbanLUClass = ((ScalarProperty) contManager.getResource(2).getData())
					.getReadAccess(this);
		
		ActualLuMap = (WritableGrid) RA_ActualLuMap.getValue();
		ActualUrbanMap = (WritableGrid) RA_ActualUrbanMap.getValue();
		UrbanLUClass = RA_UrbanLUClass;
		this.stepCount = 1;
	}
	
	@Override
	public void performModelDispose() {
		// TODO Auto-generated method stub
		releaseAccess(RA_ActualLuMap);
		releaseAccess(RA_ActualUrbanMap);
		releaseAccess(WA_ActualUrbanMap);
	}
	
	
	@Override
	public void performModelStep(int stepNo) {
		// TODO Auto-generated method stub
		statusOut.println("Starting Copy ...");
		
		boolean[][] tmpGrid = new boolean[ActualLuMap.getWidth()][ActualLuMap.getHeight()];
		
		for (int x = 0; x < ActualLuMap.getWidth(); x++)
			for (int y = 0; y < ActualLuMap.getHeight(); y++) {
				float LU = ActualLuMap.getRasterSampleAsFloat(x, y);
				float Urban = ActualUrbanMap.getRasterSampleAsFloat(x, y);
				if (!Float.isNaN(LU) && !Float.isNaN(Urban)){
					if ((int)Urban == 1){
						tmpGrid[x][y] = true;
						ActualLuMap.setRasterSample( tmpGrid[x][y] ? 1f : 0f ,x ,y);
						}
						
					}	
				}
		
		statusOut.println("Copy finished.");
	}

	

	
}