package edu.bonn.xulu.plugin.model.sleuth;

import edu.bonn.xulu.model.AbstractModelContentManager;
import edu.bonn.xulu.model.DefaultModelResource;
import edu.bonn.xulu.model.ModelResource;
import edu.bonn.xulu.model.ValuePropertyResource;
import edu.bonn.xulu.plugin.data.grid.MultiGrid;
import edu.bonn.xulu.plugin.model.clue.ClueModelContentManager;
import schmitzm.data.WritableGrid;
import schmitzm.data.property.ListProperty;
import schmitzm.data.property.ScalarProperty;


/**
 * This class defines and handles the resources for the Xulu-Model {@link MultipleResolutionValidation}
 * 
 * @see ClueModelContentManager
 * @see AverageNeighborhoodContentManager
 * @author <a href="mailto:goetzke@uni-bonn.de">Roland Goetzke</a>
 * @version 1.0
 */
public class MultipleResolutionValidationContentManager extends AbstractModelContentManager {

  /**
   * Creates a new ContentManager for the Model {@linkplain MultipleResolutionValidation}.
   */
  public MultipleResolutionValidationContentManager() {
    super(6);
    // Steps
    resource[0]	= new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Number of steps",ScalarProperty.class,Integer.class,false);
    // Reference Map
    resource[1] = new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Reference Map",ScalarProperty.class,WritableGrid.class,false);
    // Simulation Map
    resource[2] = new ValuePropertyResource(ModelResource.CATEGORY_OUTPUT,"Simulation Map",ScalarProperty.class,WritableGrid.class,false);
    // Actual Validation
    resource[3]	= new ValuePropertyResource(ModelResource.CATEGORY_OUTPUT,"Actual Validation",ScalarProperty.class,WritableGrid.class,false);
    // Map for every Resolution
    resource[4]	= new DefaultModelResource(ModelResource.CATEGORY_OUTPUT,"Step Results",MultiGrid.class,false);
    // Output Values
    resource[5]	= new ValuePropertyResource(ModelResource.CATEGORY_OUTPUT,"Validation Results",ListProperty.class,Double.class,false);
  }
}
