package edu.bonn.xulu.plugin.model.sleuth;

import schmitzm.data.WritableGrid;
import schmitzm.data.property.ScalarProperty;
import edu.bonn.xulu.data.XuluDataException;
import edu.bonn.xulu.model.AbstractModelContentManager;
import edu.bonn.xulu.model.DefaultModelResource;
import edu.bonn.xulu.model.ModelResource;
import edu.bonn.xulu.model.ValuePropertyResource;
import edu.bonn.xulu.plugin.data.grid.MultiGrid;

public class UrbanGrowthModelContentManager extends AbstractModelContentManager {
	
	public UrbanGrowthModelContentManager(int additionalRes) {
		super(13+additionalRes);
		
		resource[0] = new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Number of steps",ScalarProperty.class,Integer.class,false);
		resource[1] = new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Input Grid",ScalarProperty.class,WritableGrid.class,false);
		resource[2] = new ValuePropertyResource(ModelResource.CATEGORY_OUTPUT,"Output Grid",ScalarProperty.class,WritableGrid.class,false);
		resource[3] = new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Area Restrictions",ScalarProperty.class,WritableGrid.class,false);
		resource[4] = new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Road Grid",ScalarProperty.class,WritableGrid.class,false);
		resource[5] = new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Slope Grid",ScalarProperty.class,WritableGrid.class,false);
	    resource[6] = new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Spread Coefficient",ScalarProperty.class,Double.class,false);
	    resource[7]	= new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Dispersion Coefficient",ScalarProperty.class,Double.class,false);
	    resource[8]	= new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Breed Coefficient",ScalarProperty.class,Double.class,false);
	    resource[9] = new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"RoadGravity Coefficient",ScalarProperty.class,Double.class,false);
	    resource[10]= new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Slope Coefficient",ScalarProperty.class,Double.class,false);
	    resource[11]= new ValuePropertyResource(ModelResource.CATEGORY_INPUT,"Critical Slope",ScalarProperty.class,Double.class,false);
	    resource[12]= new DefaultModelResource(ModelResource.CATEGORY_OUTPUT,"Step Results",MultiGrid.class,false);
	    
	 	// ===== Ressourcen Bezeichnungen lokalisieren =====
	    resetCaptions(null);
	}
	
	public UrbanGrowthModelContentManager() {
		this(0);
	}
	
	
	@Override
	public void checkAndError() throws XuluDataException {
		// TODO Auto-generated method stub
		super.checkAndError();
	}
}
